/* 
 * Quicksort of N random integers
 */
#include <stdio.h>
#include <stdlib.h>

void quicksort (int v[], int, int);

#define N	10000

int v[N];

int main () {
	int t;
	int i = 0;
loop1:
	v[i++] = rand ();
	if (i < N) goto loop1;

	quicksort (v, 0, N-1);
	for (int i=0; i<N; i++) printf ("%d\n", v[i]);
	exit (0);
}

void swap (int *a, int *b) {
	int t = *a;
	*a = *b;
	*b = t;
}
 
int partition (int v[], int lo, int hi) {
	int pivot = v[hi];
	int i = lo - 1;
 
	for (int j=lo; j <= hi-1; j++) {
		if (v[j] <= pivot) {
			i++;
			swap(&v[i], &v[j]);
		}
	}
	swap(&v[i + 1], &v[hi]);
	return i + 1;
}
 
void quicksort(int v[], int lo, int hi) {
	if (lo < hi) {
		int pi = partition(v, lo, hi);
		quicksort(v, lo, pi - 1);
		quicksort(v, pi + 1, hi);
	}
}
